<template>
  <section class="c-role-board-experience">
    <article class="c-form-section">
      <Title
        :text="dataBoardExperience.board_experience_title"
        type="secondary"
      />
      <FormCondition
        id="boardExperience"
        :title="dataBoardExperience.board_experience_button_text"
        v-model="fields.boardExperience.$model"
        :error="formErrorMessagesHandler(fields.boardExperience)"
      />
    </article>

    <article
      class="c-form-section"
      v-if="fields.boardExperience.$model === 'yes'"
    >
      <Title
        :text="dataYourTbraProfile.your_tbra_profile_title"
        type="secondary"
      />
      <FormCondition
        id="yourTbraProfile"
        :title="dataYourTbraProfile.section_title"
        :description="dataYourTbraProfile.section_description"
        v-model="fields.tbraProfile.$model"
        :error="formErrorMessagesHandler(fields.tbraProfile)"
      />

      <div v-if="fields.tbraProfile.$model === 'no'">
        <Paragraph
          v-for="(text, index) in dataYourTbraProfile.section_text"
          :key="index"
          :text="text.section_text"
        />
        <section class="c-position-list">
          <article
            v-for="item in fields.tbraProfileList.$each.$iter"
            :key="item.id.$model"
            class="c-position-list__item"
            :class="isPreview ? 'c-preview-box' : ''"
          >
            <FormInput
              :id="`tbra-profile-company-${item.id.$model}`"
              v-model.trim="item.company.$model"
              :label="dataYourTbraProfile.company_name"
              :error="formErrorMessagesHandler(item.company)"
            />
            <FormSelect
              :id="`tbra-profile-entity-${item.id.$model}`"
              v-model="item.entityType.$model"
              :options="optionsEntity"
              :label="dataYourTbraProfile.type_of_entity_text"
              :error="formErrorMessagesHandler(item.entityType)"
            />
            <FormSelect
              :id="`tbra-profile-role-${item.id.$model}`"
              v-model="item.roleType.$model"
              :options="optionsRole"
              :label="dataYourTbraProfile.role_type"
              :error="formErrorMessagesHandler(item.roleType)"
            />
            <FormInput
              :id="`tbra-profile-tenure-${item.id.$model}`"
              v-model.trim="item.tenure.$model"
              :label="dataYourTbraProfile.tenure"
              :error="formErrorMessagesHandler(item.tenure)"
            />
            <FormButtonRemove @clicked="removeRoleHandler(item.id.$model)" />
          </article>
        </section>
        <FormAddRole text="Add a position" @clicked="addRoleHandler()" />
        <div
          v-if="
            fields.tbraProfileList.$error &&
              !fields.tbraProfileList.$model.length
          "
        >
          <ErrorMessage
            v-if="fields.tbraProfileList.minLength"
            :text="formErrorMessagesHandler(fields.tbraProfileList)"
            align="center"
          />
        </div>
      </div>
    </article>
  </section>
</template>

<script>
import { uuid } from "vue-uuid";
import { mapMutations } from "vuex";
import Title from "../ui/Title";
import { errorMixins } from "../mixins/formErrors";
import FormCondition from "../ui/form/FormCondition";
import Paragraph from "../ui/Paragraph";
import FormInput from "../ui/form/FormInput";
import FormSelect from "../ui/form/FormSelect";
import FormAddRole from "../ui/form/FormAddRole";
import ErrorMessage from "../ui/ErrorMessage";
import FormButtonRemove from "../ui/form/FormButtonRemove";
import { isPreviewMixin } from "../mixins/isPreview";

export default {
  name: "RoleBoardExperience",
  components: {
    FormButtonRemove,
    ErrorMessage,
    FormAddRole,
    FormSelect,
    FormInput,
    Paragraph,
    FormCondition,
    Title
  },
  props: {
    fields: {
      type: Object,
      required: true
    }
  },
  mixins: [errorMixins, isPreviewMixin],
  data: function() {
    return {
      dataBoardExperience: this.$store.state.data.data.board_experience,
      dataYourTbraProfile: this.$store.state.data.data.your_tbra_profile,
      optionsEntity: ["Private", "Public", "Listed", "Not-for Profit"],
      optionsRole: [
        "Non Executive Director",
        "Executive Director",
        "Board Secretary",
        "Chairperson",
        "Vice-Chairperson",
        "Advisory Board Member",
        "Member - Board of Trustees",
        "Member - Board of Governors",
        "Board Observer",
        "Investment Committee Member",
        "Investment Committee Chair"
      ]
    };
  },
  methods: {
    ...mapMutations(["addRole", "removeRole"]),
    addRoleHandler() {
      this.$store.commit("addRole", {
        field: "tbraProfileList",
        data: {
          id: uuid.v1(),
          company: "",
          entityType: "",
          roleType: "",
          tenure: ""
        }
      });
    },
    removeRoleHandler(id) {
      this.$store.commit("removeRole", {
        field: "tbraProfileList",
        id
      });
    }
  }
};
</script>

<style lang="scss">
.c-role-board-experience {
  .c-position-list {
    margin: 5rem 0 2rem;
    @include breakpoint(overPhone) {
      padding: 0 17.5%;
    }

    &__item {
      border-bottom: 1px solid $c-gray-secondary;
      margin-bottom: 4rem;
      padding-bottom: 4rem;

      &:last-of-type {
        border-bottom: none;
        margin-bottom: 2rem;
        padding-bottom: 2rem;
      }

      &.c-preview-box {
        max-width: 32.1rem;
        margin-right: auto;
        margin-left: auto;
      }
    }
  }
}
</style>
